/* qmain.c - Azalea QTools Command Line Utility
 
 Description - This program will return a "CueCode" type string that
  you can format in our QTools fonts

 Revision History:
 2000 Sep 15  v1.0.0 Cory R. King (coryking@azalea.com)
         Released initial version
 2000 Sep 19  v1.0.1
    Stephen Satchell (satch@flunt-access.com)
         Added linux support that lets user specify start code

    Anthony (wizkid@wizkid.org)
         Added a second (much cooler) VB front end (see ./src/cool_vb_util)
 2000 Sep 19  v1.0.2 Cory R. King
         Fixed a small compile error
	

 Notes:
  Please note that the fonts are licenced for non-commercial use only

*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <malloc.h>
#include "platform.h"

void printhelp(void);
void printbad(void);
void AzaleaQTools (BYTE *outbuf, BYTE *inbuf, WORD insize);

int 
main (int argc, char *argv[])
{
    

    extern char Q_START; // we will be modifying this

    BYTE *outbuff;
   
      switch(argc) { 
      case 2:  // just the numbers implied start of 1)
        {
	break;
        }
      case 3: // use a user specified start bar
        {
        char *p;
        unsigned long i = strtoul(argv[2], &p, 10);
      
        if ( (isdigit(*argv[2])) && (!*p) && (i > 0) && (i <100))
          {
          Q_START = i;
          }
        else
          {
          printhelp();
          exit(1);
          }
        break;
        }
        default:
	{
          printhelp();
          exit(1);
	}
      }/* end switch */
    
 
    outbuff = (BYTE *)malloc(strlen(argv[1]) + 10);

    AzaleaQTools(outbuff, (BYTE *)argv[1], (WORD)strlen(argv[1]));

    if(strlen(outbuff)==0)
	printbad();
    
    printf("%s", (char *)outbuff);
    printf("\n");

    free(outbuff);

    return(0);
}


void printhelp(void)
{
    printf("Usage: qtools [STRING] [START]\n");
    printf("Creates a string that can be formated in Azalea Software's AzaleaQTools font\n\n");

    exit(1);
}

void printbad(void) {
    printf("I'm sorry, for some reason that barcode is not valid\n");
    printf("Please verify that your input string is of even length\n");
    printf("and does not contain any alphanumaric characters\n\n");

    exit(1);
}
